//*****************************************************************************************
// Message Features functions
//*****************************************************************************************

//*****************************************************************************************
function fg_HLMessages(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlight",true)) return;

	if (fg_Debug) alert("Estamos privados");
	
	try {
		fg_listaHighlights.load();

		for (var i = fg_listaHighlights.data.length-1; i >= 0 ; i--)
		{
			var ele = fg_listaHighlights.data[i];
			switch(ele.type){
				case "CC":
					fg_HLCC(document,ele);
					break;
				case "PM":
					fg_HLPM(document,ele);
					break;
				case "SpyReport":
					fg_HLSpyRep(document,ele);
					break;
				case "SpyAlert":
					fg_HLSpyAlert(document,ele);
					break;
				case "Missile":
					fg_HLMissile(document,ele);
					break;
			}
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_HLPM(document,ele) {
	try {

		var path = '//table/tbody/tr/th[4]/child::a/img[@alt!=""]';
		var obj = fgEval(path,document);
		var others = ele.other.split('~');

		for (var i = 0; i < obj.snapshotLength; i++)
		{				
			var obj2 = obj.snapshotItem(i).parentNode.parentNode.parentNode;
			var tok = 1;
			var modo = fg_parseInt(others[0]);
			if (modo % 2 == 1) {
				var searchFrom = others[tok].split('\n');
				var text = obj2.firstChild.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.firstChild.nodeValue;
				if (!fg_findAny(text,searchFrom))
						continue;
				tok++;
			}
			modo = (modo - (modo % 2))/2;
			if (modo % 2 == 1) {
				var searchText = others[tok].split('\n');
				var td = obj2.nextSibling.nextSibling.firstChild.nextSibling.nextSibling;
				var text = td.innerHTML;
				if (!fg_findAny(text,searchText))
					continue;
				tok++;
			}
			modo = (modo - (modo % 2))/2;
			if (modo % 2 == 1) {
				var searchAbout = others[tok].split('\n');
				var text = obj2.firstChild.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.firstChild.nodeValue;
				if (!fg_findAny(text,searchAbout))
						continue;
				tok++;
			}

			//HL Nodes
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
			}

		}

	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_HLSpyRep(document,ele) {
	try {
		var path='//td[@colspan="3"][@class="b"]/table[@width="400"][1]/tbody/tr[2]';
		var others = ele.other.split('~');
		var obj = fgEval(path,document);

		var modo = fg_parseInt(others[0]);
		for (var i = 0; i < obj.snapshotLength; i++)
		{		
			var obj2 = obj.snapshotItem(i).parentNode.parentNode.parentNode.parentNode;
			var modoTemp = modo;
			if (modoTemp >= 4) {
				var path1 = './td[2]/table[3]/tbody/tr[1]';
				var path2 = './td[2]/table[3]/tbody/tr[2]';
				if (fgEvalnode(path1,document,obj2).snapshotLength == 0 || fgEvalnode(path2,document,obj2).snapshotLength > 0)
					continue;
				modoTemp -= 4;
			} 
			if (modoTemp >= 2) {
				var path1 = './td[2]/table[4]/tbody/tr[1]';
				var path2 = './td[2]/table[4]/tbody/tr[2]';
				if (fgEvalnode(path1,document,obj2).snapshotLength == 0 || fgEvalnode(path2,document,obj2).snapshotLength > 0)
					continue;
				modoTemp -= 2;
			}
			if (modoTemp >= 1) {
				var tr2 = obj.snapshotItem(i);
				var metal = tr2.firstChild.nextSibling.innerHTML;
				var cristal = tr2.firstChild.nextSibling.nextSibling.nextSibling.nextSibling.innerHTML;
				var deut = tr2.nextSibling.nextSibling.firstChild.nextSibling.innerHTML;
				var total = fg_parseInt(metal) + fg_parseInt(cristal) + fg_parseInt(deut);
				switch(others[2]) {
					case "Metal":
						if (fg_parseInt(others[1]) > fg_parseInt(metal))
							continue;
						break;
					case "Cristal":
						if (fg_parseInt(others[1]) > fg_parseInt(cristal))
							continue;
						break;
					case "Deuterio":
						if (fg_parseInt(others[1]) > fg_parseInt(deut))
							continue;
						break;
					case "Total":
						if (fg_parseInt(others[1]) > total)
							continue;
						break;
				}
			}

			//HL Nodes
			var nodes = obj2.previousSibling.previousSibling.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
			}
			nodes = obj2.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
			}
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_HLSpyAlert(document,ele) {
	try {
		var path = '//span[@class="espionagereport"]';
      	var obj = fgEval(path,document);
      	if (obj.snapshotLength == 0) return;
      	for (var i = 0; i < obj.snapshotLength; i++)
      	{
         		var obj2 = obj.snapshotItem(i).parentNode.parentNode;
         		tr2 = obj2.nextSibling.nextSibling;
         		var tr3 = fgEvalnode('.//table/tbody/tr[1]',document,tr2);
         		if (tr3.snapshotLength == 0) {
            		var nodes = obj2.childNodes;
            		for (var j = 0; j < nodes.length; j++) {
               			if (nodes[j].nodeName != "#text")
                  			nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
            		}
            		nodes = obj2.nextSibling.nextSibling.childNodes;
            		for (var j = 0; j < nodes.length; j++) {
               			if (nodes[j].nodeName != "#text")
                  			nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
            		}
         		}
	     	}
   	} catch (e) {
      	foxgamedebug(e);
   	}
}

//*****************************************************************************************
function fg_HLMissile(document,ele) {
	try {
    		var path = '//table/tbody/tr/td[@colspan="3"][@class="b"]/table[@width=400]';
      	var obj = fgEval(path,document);
      	if (obj.snapshotLength == 0) return;
      	for (var i = 0; i < obj.snapshotLength; i++)
      	{
         		var obj2 = obj.snapshotItem(i).parentNode.parentNode;
         		tr2 = obj2.previousSibling.previousSibling;
         		var tr3 = fgEvalnode('.//th[4]/child::span[@class="espionagereport"]',document,tr2);
         		if (tr3.snapshotLength == 0) {
            		var nodes = tr2.childNodes;
            		for (var j = 0; j < nodes.length; j++) {
               			if (nodes[j].nodeName != "#text")
                  			nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
            		}
            		nodes = obj2.childNodes;
            		for (var j = 0; j < nodes.length; j++) {
               			if (nodes[j].nodeName != "#text")
                  			nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
            		}
         		}
      	}
	} catch (e) {
      foxgamedebug(e);
   }
}

//*****************************************************************************************
function fg_HLCC(document,ele) {
	try {
		var path='//table/tbody/tr/th[3]';
		var others = ele.other.split('~');
		var obj = fgEval(path,document);

		for (var i = 0; i < obj.snapshotLength; i++)
		{		
			var from = obj.snapshotItem(i).innerHTML;
			if (from.stripHTMLEntities().trim() == "")	//Fix for ogame.com.pt 
				from = obj.snapshotItem(i).nextSibling.innerHTML;
			var found = from.match(/\[.*\]/);
			if (!found) continue;
			if (fg_isCoord(found[0])) continue;
			
			switch(others[0]){
				case '1':
				case '3':
					var searchFrom = others[1];
					var td = obj.snapshotItem(i).parentNode.nextSibling.nextSibling.firstChild.nextSibling.nextSibling;
					var text = td.firstChild.nodeValue;
					if (text.search(searchFrom) == -1)
						continue;
					if (others[0] == '1')
						break;
				case '2':
					if (others[0] == '2')
						var searchText = others[1];
					else
						var searchText = others[2];
					var td = obj.snapshotItem(i).parentNode.nextSibling.nextSibling.firstChild.nextSibling.nextSibling;
					var text = td.firstChild.nextSibling.nextSibling.nodeValue;
					if (text.search(searchText) == -1)
						continue;
				break;
			}

			//HL node
			var obj2 = obj.snapshotItem(i).parentNode;
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+ele.color+"; background-image : none;");
			}
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_replicateOptions(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	
	if (fg_Debug) alert("Estamos replicado de opciones");
	
	try {
		if (fgGetBooleanPref("foxgameReplicateSpyReportOptions",false)) 
		{

			var path = '//table/tbody/tr/th/input[@name="fullreports"]';
			var row = fgEval(path,document);
			if (row.snapshotLength == 0) return;
			row = row.snapshotItem(0).parentNode.parentNode;
			var row2 = row.cloneNode(true);
			row.firstChild.nextSibling.firstChild.setAttribute("id","fullreports");
			row.firstChild.nextSibling.firstChild.setAttribute("onchange","document.getElementById('fullreports2').checked=this.checked");

			row2.firstChild.nextSibling.firstChild.setAttribute("name","fullreports2");
			row2.firstChild.nextSibling.firstChild.setAttribute("id","fullreports2");
			row2.firstChild.nextSibling.firstChild.setAttribute("onchange","document.getElementById('fullreports').checked=this.checked");
			row.parentNode.insertBefore(row2,row.parentNode.firstChild);

		} 
		if (fgGetBooleanPref("foxgameReplicateDeleteOptions",true)) 
		{

			var path = '//table/tbody/tr/th/select[@name="deletemessages"]';
			var row = fgEval(path,document);
			if (row.snapshotLength == 0) return;
			row = row.snapshotItem(0).parentNode.parentNode;
			var row2 = row.cloneNode(true);
			row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages");
			row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages2').options[this.selectedIndex].selected='true'");
	
			row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("name","deletemessages2");
			row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages2");
			row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages').options[this.selectedIndex].selected='true'");
			row.parentNode.insertBefore(row2,row.parentNode.firstChild);		
		}
		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//table[@width="519"]', document)
		if (table.snapshotLength == 0) return;
		table = table.snapshotItem(0);
		var form = fgEval (
			'//form[starts-with(@action,"index.php?page=messages")]', document);
		if (form.snapshotLength == 0) return;
		form = form.snapshotItem(0);
		form.parentNode.removeChild(form);
		table.parentNode.insertBefore(form,table);
		table.parentNode.removeChild(table);
		form.appendChild(table);
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addReportButtons(document) {
	return;
	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddReportButtons",false)) return;

	if (fg_Debug) alert("Estamos milos");
	
	try {

	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];

	//Insertamos el .js con la funcion de envio del formulario
	fg_addJavaScript(document, "chrome://foxgame/content/resources/js/milosReport.js");

	//Creamos el Iframe donde se mostraran los resultados de la inclusion
	var div = document.createElement('div');
	div.innerHTML = fg_MilosDiv;

	//Creamos el div donde se meter el formulario
	form = document.createElement('div');


	if (ele.type == "OGSpy" || ele.type == "GalaxieTool") {

	      var path = '//table[@width="519"]';
      	var obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;

		//Creamos la fila donde meter el nuevo boton
		var tr = document.createElement('tr');
		var td = document.createElement('td');
		tr.appendChild(td);
		td.setAttribute("colspan","4");
		td.setAttribute("class","1");
		td.setAttribute("align","center");
		td.setAttribute("valign","middle");

		if (ele.type == "OGSpy") {
			//-------------------------------------
			var Selection = window.getSelection();
			if(Selection.rangeCount > 0) Selection.removeAllRanges();
	
		     	var range = document.createRange();
	      	range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

		      var path = '//div[starts-with(@id,"tOoLtIp")]';
      		var obj = fgEval(path,document);
			for (var i = 0; i < obj.snapshotLength; i++) {
			     	var range = document.createRange();
			      range.selectNode(obj.snapshotItem(i));
				Selection.addRange(range);

			}
			text = Selection.toString();
					
			//Creamos el formulario con los datos almacenados
			var temp = ele.other.split("[]");
			form.innerHTML += '<form action="'+ele.other+'" method=post target="_milos" id="milos_form" >'+
					'<input type=hidden name="action" value="get_data">'+
					'<input type="hidden" name="datatype" value="basic">'+
					'<input type=hidden name=data value="'+text+'">';
			td.innerHTML += "<input type=button value=\""+ele.type+"\" onClick=\"next('');\">";

		} else if (ele.type == "GalaxieTool") {
		//----------------------------------------

			//Cogemos la tabla de los mensajes y la formateamos para que se pueda meter como input
			var texto = obj.snapshotItem(0).innerHTML;
			texto = texto.replace(/'/ig,"");

			//Creamos el formulario con los datos almacenados
			var temp = ele.other.split("[]");
			form.innerHTML = '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form"  accept-charset="utf-8">'+
				'<input type=hidden name="user" value="'+temp[0]+'">'+
				'<input type=hidden name="password" value="'+temp[1]+'">'+
				'<input type=hidden name="typ" value="reports">'+
				//'<textarea name=content rows=1 cols=75>'+texto+'</textarea>';
				"<input type=hidden name='content' value='"+texto+"'>";

			td.innerHTML += "<input type=button value=\""+ele.type+"\" onClick=\"document.getElementById('milos_form').submit();\">";
		//------------------------------------------
		}

		//Metemos el formulario oculto al final del body con el div del iframe
		fg_appendBody(document,form);	
		form.appendChild(div);
		
		//Buscamos donde meter el nuevo boton y lo metemos
		var tds = fgEval('//table[@width="519"]/child::tbody', document);
		if (tds.snapshotLength > 0)
			tds.snapshotItem(0).insertBefore(tr,tds.snapshotItem(0).firstChild);	
		return;
	}

	var path = '//span[@class="espionagereport"]';
     	var obj = fgEval(path,document);

	if (obj.snapshotLength == 0) return;

	//Para cada espionaje creamos un formulario nuevo y metemos un boton detras de cada espionaje.

	for (var i = 0; i < obj.snapshotLength; i++) 
	{
		var tr2 = obj.snapshotItem(i).parentNode.parentNode;
		tr2 = tr2.nextSibling.nextSibling;
	
		//Sacamos lo que tendriamos si le dieramos a copiar y pegar
		var tr3 = fgEvalnode('.//table/tbody/tr[1]',document,tr2);
		if (tr3.snapshotLength == 0) continue;

     		var range = document.createRange();
		var text = "";
		for (var j = 0; j < tr3.snapshotLength; j++) {
			tr = tr3.snapshotItem(j);
			while (tr != null)
 			{
				if (tr.nodeName == 'TR') {
					td = tr.firstChild;
					while (td != null) {
						if (td.nodeName == 'TD' || td.nodeName == 'TH'){
					      	range.selectNode(td);
							text += range.toString().retrim()+"\t";
						}
						td = td.nextSibling;
					}
					text = text.substr(0,text.length-1)+"\n";
				}
				tr = tr.nextSibling;
			}
		}
		range.detach;

		//Creamos una nueva fila en la tabla para el boton
		tr2 = tr2.nextSibling.nextSibling;
		var th = document.createElement('th');
		th.setAttribute('colspan','4');

		//Aadimos otro formulario ms al div de los formularios
		if (ele.type == "Milos") {
			var temp = ele.other.split("[]");
			form.innerHTML += '<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form'+i+'">'+
				'<input type=hidden name="milos_login[user]" value="'+temp[0]+'">'+
				'<input type=hidden name="milos_login[passwd]" value="'+temp[1]+'">'+
				'<input type=hidden name="milos_login[group]" value="'+temp[2]+'">'+
				'<input type=hidden name="milos_login[sg]" value="'+temp[3]+'">'+
				'<input type=hidden name="milos_login[r]" value="">'+
				'<input type=hidden name="show" value="checked">'+
				'<input type=hidden name="noncommit" value="">'+
				'<input type=hidden name="delafter" value="checked">'+
				'<input type=hidden name=x value="'+text+'">';
		} else if (ele.type == "EspRep") {
			form.innerHTML += '<form action="http://www.esprep.org/general/dump.php?quick=1" method=post target="_milos" id="milos_form'+i+'" accept-charset="utf-8">'+
				'<input type=hidden name="show" value="Process Dump (Show Results)">'+
				'<input type="hidden" name="espplayer" value="none">'+
				'<input type="hidden" name="espalliance" value="none">'+
				'<input type=hidden name=dump value="'+text+'">';
		}
		th.innerHTML += "<input type=button value=\""+ele.type+"\" onClick='next("+i+");'></form>";
		tr2.parentNode.insertBefore(th,tr2);	
	}

	form.appendChild(div);
	fg_appendBody(document,form);
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addSignature(document) {

	if (document && !fg_isWriteMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameMessageSignature",true)) return;

	
	if (fg_Debug) alert("Estamos firmas mensajes");
	
	try {

		var path = '//textarea[@name="text"]';
		var obj = fgEval(path,document);
		try {
			var signature = PrefsBranchFG.getCharPref("fgMsgSign");
		} catch(e) { var signature ="";}


		if (obj.snapshotLength == 0) return;
		obj = obj.snapshotItem(0);
		obj.value = signature;
	} catch(e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_dragoSimLink(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameDragoSimLink",false)) return;

	
	if (fg_Debug) alert("Estamos dragosim");
	
	try {

		var table = fgEval('//tr/th/span[@class="espionagereport"]/parent::*/parent::*/following-sibling::tr[1]/td[@colspan="3"][@class="b"]/table/parent::*', document);	

		var lang = fg_findLang(document,fg_server_lang);
		
		var table2, text, sel;
		sel = window.getSelection();
		for (var i = 0; i < table.snapshotLength; i++) {
			table2 = table.snapshotItem(i);
	
			sel.removeAllRanges();
	
		     	var range = document.createRange();
      		range.selectNode(table2.parentNode);
			sel.addRange(range);

			text = sel.toString();
			text = text.replace(/\r|\n/,' ');
			
			ruta = "http://drago-sim.com/index.php?lang="+lang;
			ruta +="&scan="+text;
			var a = document.createElement('a');
			a.setAttribute('href',ruta);
			a.setAttribute('target','_blank');
			var img = document.createElement('img');
			img.setAttribute("src","chrome://foxgame/content/resources/images/drago.gif");
			img.setAttribute('border','0');
			img.setAttribute('align','absbottom');
			a.appendChild(img);
			var prevRow = table2.parentNode.parentNode.rows[table2.parentNode.rowIndex -1];
			prevRow.cells[prevRow.cells.length-1].appendChild(a);
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_speedSimLink(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameSpeedSimLink",false)) return;
	
	if (fg_Debug) alert("Estamos speedsim");
	
	try {

		var table = fgEval('//tr/th/span[@class="espionagereport"]/parent::*/parent::*/following-sibling::tr[1]/td[@colspan="3"][@class="b"]/table/parent::*', document);	
		
		var lang = fg_findLang(document,fg_server_lang2);
		
		var table2, text, sel;
		sel = window.getSelection();
		for (var i = 0; i < table.snapshotLength; i++) {
			table2 = table.snapshotItem(i);
	
			sel.removeAllRanges();
	
		    var range = document.createRange();
      		range.selectNode(table2.parentNode);
			sel.addRange(range);

			text = sel.toString();
			text = text.replace(/\r|\n/,' ');
			
			ruta = "http://websim.speedsim.net/index.php?lang="+lang;
			//ruta = "http://websim.speedsim.net/";
			var form = document.createElement('div');
			form.innerHTML = '<form action="'+ruta+'" method=post target="_speedsim" name="speedsim_form" id="speed_'+i+'" >'+
					'<input type="hidden" name="report" id="input_sso" value="'+encodeURI(text)+'"></form>';
			document.body.appendChild(form);
			var a = document.createElement('a');
			a.setAttribute('href','#');
			a.setAttribute('onclick','document.getElementById("speed_'+i+'").submit();');
			var img = document.createElement('img');
			img.setAttribute("src","chrome://foxgame/content/resources/images/speedsim.gif");
			img.setAttribute('border','0');
			img.setAttribute('align','absbottom');			
			a.appendChild(img);
			var prevRow = table2.parentNode.parentNode.rows[table2.parentNode.rowIndex -1];
			prevRow.cells[prevRow.cells.length-1].appendChild(a);
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addRaid(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddRaid",true)) return;
	
	if (fg_Debug) alert("Estamos raid");

	try {
			var size = fg_parseInt(PrefsBranchFG.getCharPref("foxgameAddRaidSize"));
	} catch(e) { var size = 25000;}
	
	try {
		var tr = fgEval('//tr/th/span[@class="espionagereport"]/parent::*/parent::*/following-sibling::tr[1]/td[@colspan="3"][@class="b"]/table[@width="400"][1]/tbody/tr[2]', document);	

		var tr2, text, metal, cristal, deut, total, total2;
		for (var i = 0; i < tr.snapshotLength; i++) {
			tr2 = tr.snapshotItem(i);
			metal = tr2.firstChild.nextSibling.innerHTML;
			cristal = tr2.firstChild.nextSibling.nextSibling.nextSibling.nextSibling.innerHTML;
			deut = tr2.nextSibling.nextSibling.firstChild.nextSibling.innerHTML;
			total = fg_parseInt(metal) + fg_parseInt(cristal) + fg_parseInt(deut);
			total2 = fg_calcMinFleet(fg_parseInt(metal)/2, fg_parseInt(cristal)/2, fg_parseInt(deut)/2, size); 
			
			tr3 = document.createElement('tr');
            var font = document.createElement("font");
            font.setAttribute("color","orange");
	 		var span = document.createElement("span");
            span.setAttribute("class","raid");                
            font.appendChild(span);
            var td = document.createElement('td');
            td.appendChild(font);
           	var td1 = td.cloneNode(true);
           	tr3.appendChild(td1);
           	td1.firstChild.firstChild.appendChild(document.createTextNode(messages.GetStringFromName("foxgame.inner.Total")));
			td1 = td.cloneNode(true);
           	tr3.appendChild(td1);
           	td1.firstChild.firstChild.appendChild(document.createTextNode(fg_NumberFormat(total)));			
			td1 = td.cloneNode(true);
           	tr3.appendChild(td1);
           	td1.firstChild.firstChild.appendChild(document.createTextNode(messages.GetStringFromName("foxgame.inner.Raid")));			
			td1 = td.cloneNode(true);
           	tr3.appendChild(td1);
           	td1.firstChild.firstChild.appendChild(document.createTextNode(fg_NumberFormat(total2)));			
			tr2.parentNode.appendChild(tr3);
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_calcMinFleet(metal, crystal, deut, size) {
	
	var  total2 = (metal + crystal + deut)/size;
	if (Math.round(total2) != total2)
		total2 = Math.round(total2) + 1;
	var ok = false;
	do {
		var auxMetal = metal;
		var auxCrystal = crystal;
		var totalSize = total2 * size;
		var maxMetal = Math.floor(totalSize/3);
		if (maxMetal > auxMetal) {
			totalSize = totalSize - auxMetal;
			auxMetal = 0;
		} else {
			totalSize = totalSize - maxMetal;
			auxMetal = auxMetal - maxMetal;
		}			
		var maxCrystal = Math.floor(totalSize/2);
		if (maxCrystal > auxCrystal) {
			totalSize = totalSize - auxCrystal;
			auxCrystal = 0;
		} else {
			totalSize = totalSize - maxCrystal;
			auxCrystal = auxCrystal - maxCrystal;
		}
		if (totalSize > deut) {
			totalSize = totalSize - deut;			
		} else {
			total2++; //Not enough space for all deut.
			continue;
		}
		var maxMetal = Math.floor(totalSize/2);
		if (maxMetal > auxMetal) {
			totalSize = totalSize - auxMetal;
			auxMetal = 0;
		} else {
			total2++; //Not enough space for all metal.
			continue;
		}			
		if (totalSize > auxCrystal) {
			totalSize = totalSize - auxCrystal;
			auxCrystal = 0;
			ok = true;
		} else {
			total2++; //Not enough space for all crystal.
			continue;
		}		
	} while (!ok);
	return total2;
}
//*****************************************************************************************
// Code from SA
//*****************************************************************************************	
function fg_fastReply(document){
  	if (!document) return;  // no url check
  	if (document && !fg_isMessagesUrl(document.location.href)) return;

	var active = fgGetBooleanPref("foxgameFastReply",false);
	try {
	
		if (active) {
			fg_addJavaScript(document,"chrome://foxgame/content/resources/js/anon_messagesctrl.js");
			fg_addJavaScript(document,"chrome://foxgame/content/resources/js/ajax.js");
			var localText = 'var fg_LOCAL = {' 
			+ '\n CircMsg : "' + messages.GetStringFromName("foxgame.inner.CircMsg") + '",'
			+ '\n PMMsg : "' + messages.GetStringFromName("foxgame.inner.PMMsg") + '",'
			+ '\n Recipient : "' + messages.GetStringFromName("foxgame.inner.Recipient") + '",'	
			+ '\n Subject : "' + messages.GetStringFromName("foxgame.inner.Subject") + '",'
			+ '\n Clean : "' + messages.GetStringFromName("foxgame.inner.Clean") + '",'
			+ '\n Close : "' + messages.GetStringFromName("foxgame.inner.close") + '",'
			+ '\n EQuote : "' + messages.GetStringFromName("foxgame.inner.EQuote") + '",'
			+ '\n Quote : "' + messages.GetStringFromName("foxgame.inner.Quote") + '",'
			+ '\n Send : "' + messages.GetStringFromName("foxgame.inner.Send") + '",'
			+ '\n Error : "' + messages.GetStringFromName("foxgame.inner.Error") + '"'
			+ '\n};\n';
			fg_loadJs(document,localText);
		}		
		var msgs = new fg_FastReply();
	
		var path = '//table/tbody/tr/th[4]/child::a/img[@alt!=""]';
		var obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++ ){		
			var tr = obj.snapshotItem(i).parentNode.parentNode.parentNode;
			if (active)
				msgs.onPrivateMessage(tr,document);
			else {
				var msgContent    = tr.nextSibling.nextSibling.cells[1];
				msgContent.innerHTML = msgs.quote2html(msgContent.innerHTML);		
			}
		}
		path='//table/tbody/tr/th[3]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++)
		{		
			var from = obj.snapshotItem(i).innerHTML;
			if (from.stripHTMLEntities().trim() == "")	//Fix for ogame.com.pt 
				from = obj.snapshotItem(i).nextSibling.innerHTML;
			var found = from.match(/\[.*\]/);
			if (!found) continue;
			if (fg_isCoord(found[0])) continue;
			var tr = obj.snapshotItem(i).parentNode;
			if (active)
				msgs.onCircularMessage(tr, document);
			else { 
				var msgContent    = tr.parentNode.rows[tr.rowIndex+1].cells[1];
				msgContent.innerHTML = msgs.quote2html(msgContent.innerHTML);
			}				
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_FastReply(){

  // NOTICE: .createDivInside(object, IID, wrap, display)
  //         wraps content of object inside new DIV if wrap argument true, and sets display state.
  //
  this.createDivInside = function(object, IID, wrap, display)
  {
    // use object.document cause IE for change forbids access from parent lol
    var div = object.ownerDocument.createElement('div');
    try {
      div.id = IID;
      if(wrap){
      	var temp = object.innerHTML;
      	object.innerHTML = '';
        div.innerHTML = temp;        
      };
      object.appendChild(div);
      div.style.display = display;
    }catch(e){ foxgamedebug(e);};
    return div;
  };

  this.trimMulti = function(exp)
  {
  	return exp.replace(/^[ \n]*|[ \n]*$/g,'');
  };

  this.filter = function(text, compress)
  {
      text = text.replace(/[\x20]{1,}/igm,' ');           // compress spacing '  ' -> ' '
      text = text.replace(/[\x0b\r\n]{2,}/igm,'\n\n');    // compress lines to double
      if (compress) text = text.replace(/[\n]+/igm,'\n'); // compress double lines to single
      return this.trimMulti(text);
  };
  
  this.quote2html   = function(html)
  {
      var htmlEQ    = '<div style="border:3px #415680 double;padding:1px 4px 2px 4px;">'
      				+ messages.GetStringFromName("foxgame.inner.Quote") + ' (<b style="color:white">$1'
      				+ '</b> )</div><div style="border:3px #415680 double;padding:4px 4px 6px 4px; border-top: none;">';
      var htmlEQ2   = '<div style="border:3px #415680 double;padding:1px 4px 2px 4px;">'
      				+ messages.GetStringFromName("foxgame.inner.Quote") 
      				+ '</div><div style="border:3px #415680 double;padding:4px 4px 6px 4px; border-top: none;">';      				
      var htmlEQEnd = '</div>';	  
	  var reEQ      = /\[quote=(.*?)\]/igm;
	  var reEQ2     = /\[quote\]/igm;	  	  
	  var reEQEnd   = /\[\/quote\]/igm;
	  html = html.replace(reEQ, htmlEQ);
	  html = html.replace(reEQ2, htmlEQ2);
      html = html.replace(reEQEnd,htmlEQEnd);
      return html;
    };

  //--------------------------------------------------------------------------------------------
  //
  // CIRCULAR MESSAGE (rows = 3)
  //
  this.onCircularMessage = function(tr, document)
  {

    var header        = tr.cells;
    var report        = tr.parentNode.rows[tr.rowIndex+2].cells;    
    var headerFrom    = header[2];
    var headerSubject = header[3];
    var msgContent    = tr.parentNode.rows[tr.rowIndex+1].cells[1];
    // CRAPPY COMMANDER SUPPORT
	
	var reportUser = null;
	var showReport = true;
	if (report.length != 1 || report[0].firstChild.nextSibling.nodeName == "SELECT") {
		showReport = false;
      	var newrow = document.createElement('tr');
      	var newcell = document.createElement('td');
        newcell.setAttribute('colspan',4);
        newrow.appendChild(newcell);
      	try {
        	var table = tr.parentNode;
        	table.insertBefore(newrow,tr.nextSibling.nextSibling.nextSibling);
      	}catch(e){
        	foxgamedebug(e);
      	}
      	report = newrow.cells;	
	}    	
	reportUser = report[0];
    	
    var IID_REPORT    = 'IID_REPORT_'+tr.rowIndex;
    var IID_CIRC      = 'IID_CIRC_'+tr.rowIndex;
	var IID_MSG	  	  = 'IID_MSG_'+tr.rowIndex;    
    //reportUser.style.display = 'none';
    
    var p = msgContent.innerHTML.indexOf(':');
    if(p>-1){
      //headerFrom.textContent = 'Circular Message';
      headerSubject.textContent = msgContent.innerHTML.substring(0,p+1);
      msgContent.innerHTML = msgContent.innerHTML.substring(p+1,msgContent.innerHTML.length).replace(/\<br\><br\>/ig,"<br/>").replace(/^\<br\>/i,'');
    }
    
    try {
       	var divReportUser = this.createDivInside(reportUser, IID_REPORT, true,  'none');
        	 
    	var divCirc = document.createElement('div');
      	divCirc.id = IID_CIRC;
   		reportUser.appendChild(divCirc);
      	divCirc.style.display = 'none';        

        divCirc.setAttribute('msgSubject',  headerFrom.textContent);
        divCirc.setAttribute('msgText',     this.filter(msgContent.textContent, true));
        divCirc.setAttribute('msgURLCirc',  'index.php?page=allianzen&session='+fg_getHashProperty(document.location.href,'session')+'&a=17&sendmail=1');

        // TODO: add locate member info for fast reply to member
        var member = fg_getAllyPIN(document, headerSubject.textContent);
        if (member!=null){
          // ?page=writemessages&session=d5580ff3f26a&messageziel=100205&re=1&betreff=Re:no%20subject
          divCirc.setAttribute('msgURL',    'index.php?page=writemessages&session='+fg_getHashProperty(document.location.href,'session')+'&messageziel='+member[0]);
          divCirc.setAttribute('msgTo',     member[1] + ' [::]');
        } else {
        	divCirc.setAttribute('msgTo',     headerFrom.textContent);
        }
        var signature ="";
		if (fgGetBooleanPref("foxgameMessageSignature",true)) {
			try {
				signature = PrefsBranchFG.getCharPref("fgMsgSign");
			} catch(e) { ;}
		}
        divCirc.setAttribute('msgSig', signature);        
        var SQ = "'";
        var CircText = messages.GetStringFromName("foxgame.inner.CircReply");
        var PMText = messages.GetStringFromName("foxgame.inner.PMReply");        
        var RText = messages.GetStringFromName("foxgame.inner.Report");
        msgContent.innerHTML = this.quote2html(msgContent.innerHTML);
        msgContent.innerHTML += '<div style="width:100%;text-align:right;color:#808080;">'
                              + ((showReport)?('[<a href="javascript:FGMessages.compact(document,'+SQ+IID_REPORT+SQ+');"><b style="color:red">'+RText+'</b></a>] '):(''))                                                           
                              + '[<a href="javascript:FGMessages.onFastCircReply(document,'+SQ+IID_CIRC+SQ+',10);"><b>'+CircText+'</b></a>]'
                              + ((member!=null)?(' [<a href="javascript:FGMessages.onFastReply(document,'+SQ+IID_CIRC+SQ+',10);"><b>'+PMText+'</b></a>]'):(''))
                              + '</div>';

        //----------------------------------------------------------------------------
    }catch(e){ foxgamedebug(e); };

  };
  //--------------------------------------------------------------------------------------------
  //
  // PRIVATE MESSAGE (rows = 3)
  //
  this.onPrivateMessage = function(tr, document)
  {
    var headerFrom    = tr.cells[2];
    var headerSubject = tr.cells[3];
    
    var msgContent    = tr.nextSibling.nextSibling.cells[1];
    var reportUser    = tr.nextSibling.nextSibling.nextSibling.nextSibling.cells[0];
    var IID_REPORT    = 'IID_REPORT_'+tr.rowIndex;
    var IID_REPLY	  = 'IID_REPLY_'+tr.rowIndex;

    try {
        // prepare text first (compact it and similar staff)
        var obj = fgEvalnode('a',document,headerSubject);
        var a = obj.snapshotItem(obj.snapshotLength-1);
        var divReportUser = this.createDivInside(reportUser, IID_REPORT, true,  'none');
    	var divReply = document.createElement('div');
      	divReply.id = 'IID_REPLY_'+tr.rowIndex;      
      	reportUser.appendChild(divReply);
      	divReply.style.display = 'none';        
        divReply.setAttribute('msgTo',      headerFrom.textContent);
        divReply.setAttribute('msgSubject', headerSubject.textContent);
        divReply.setAttribute('msgText',    this.filter(msgContent.textContent, true));
        divReply.setAttribute('msgURLCirc', 'index.php?page=allianzen&session='+fg_getHashProperty(document.location.href,'session')+'&a=17&sendmail=1');
        var signature ="";
		if (fgGetBooleanPref("foxgameMessageSignature",true)) {
			try {
				signature = PrefsBranchFG.getCharPref("fgMsgSign");
			} catch(e) { ;}
		}
        divReply.setAttribute('msgSig', signature);		        
        if (a!=null){
          divReply.setAttribute('msgURL',   a.href.substring(('http://'+document.location.host+'/game/').length));
        }else{
          return;
        };
        var SQ = "'";
        var CircText = messages.GetStringFromName("foxgame.inner.CircReply");
        var PMText = messages.GetStringFromName("foxgame.inner.PMReply");
        var RText = messages.GetStringFromName("foxgame.inner.Report");
        msgContent.innerHTML = this.quote2html(msgContent.innerHTML);
        msgContent.innerHTML += '<div style="width:100%;text-align:right;color:#808080;">'
                              + '[<a href="javascript:FGMessages.compact(document,'+SQ+IID_REPORT+SQ+');"><b style="color:red">'+RText+'</b></a>] '
                              + '[<a href="javascript:FGMessages.onFastCircReply(document,'+SQ+IID_REPLY+SQ+',10);"><b>'+CircText+'</b></a>]'
                              + '[<a href="javascript:FGMessages.onFastReply(document,'+SQ+IID_REPLY+SQ+',10);"><b>'+PMText+'</b></a>]</div>';
        //----------------------------------------------------------------------------
    }catch(e){ foxgamedebug(e); };
  };
  return this;
};
